#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf acpid-1.0.10.tar.gz
    cd acpid-1.0.10
    ed -s Makefile >/dev/null <<EOF
/^CFLAGS =/
s/\W-g\W/ $CFLAGS /
.
w
q
EOF
    make
    strip -R .note -R .comment acpid
    mkdir -p ../acpid/sbin
    cp acpid ../acpid/sbin/
    cd ..
    rm -rf acpid-1.0.10
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
